var authenticate = {
	isLoggedIn: false,

	initialize: function() {
		this.bindEvents();
	},
	bindEvents: function() {
        document.addEventListener('deviceready', this.deviceReady, false);
	},
	deviceReady: function() {
		authenticate.checkLogin();
		$("#loginbutton").click(authenticate.login);
		$("#logoutbutton").click(authenticate.logout);
	},
	login: function() {
		// get username and password
		var username = $("#username").val();
		var password = $("#password").val();
		var data = {username:username, password:password, uuid:device.uuid, devicename:(device.model ? device.model : "")+" "+(device.name ? device.name : "")};
		// ajax to login url
		$.ajax({
			type: "POST",
			crossDomain: true,
			url: app.mobileBaseUrl+app.loginUrl,
			data: data,
			timeout: app.timeout,
			success: function(json) {
				// get generated shared key, personid and username
				// and persist it to local store
				if(!(json.sessionId === null)) {
					window.localStorage.setItem("sessionId", json.sessionId);
					window.localStorage.setItem("personId", json.personId);
					window.localStorage.setItem("username", json.username);
					$("#logoutlink").show();
					$("#loginlink").hide();
					$("#username").val("");
					$("#password").val("");
					authenticate.isLoggedIn = true;
					logger.info("AUTHENTICATE: LOGIN: SUCCESS");
					app.refreshData();
					$(":mobile-pagecontainer").pagecontainer( "change", "#home");
					whatsnew.displayWhatsnew();
				} else {
					navigator.notification.alert("Incorrect username or password.", function() {}, "Error", "Ok");
					$("#password").val("");
				}
			},
			error: function(e) {
			    navigator.notification.alert("Login failed", function () { }, "Error", "Ok");
				logger.error("AUTHENTICATE: LOGIN: ERROR: ("+app.mobileBaseUrl+app.logoutUrl+")"+JSON.stringify(e));
			}
		});
	}, 
	logout: function() {
		navigator.notification.confirm(
			'Are you sure you want logout and clear all app data?',
			function(buttonIndex) {
				if(buttonIndex == 1) {
					var data = {username:window.localStorage.getItem("username"), uuid:device.uuid};
					// ajax to login url
					$.ajax({
						type: "POST",
						crossDomain: true,
						url: app.mobileBaseUrl+app.logoutUrl,
						data: data,
						timeout: app.timeout,
						success: function(json) {
							window.localStorage.clear();
							authenticate.checkLogin();
							logger.info("AUTHENTICATE: LOGOUT: SUCCESS");
						},
						error: function(e) {
							logger.error("AUTHENTICATE: LOGOUT: ERROR: ("+app.mobileBaseUrl+app.logoutUrl+")"+JSON.stringify(e));
						}
					});
				}
			},            			
			'Log out?',           
			['Yes','No']  
		);
	}, 
	checkLogin: function() {
		// check existence of shared secret in local store
		if(!(window.localStorage.getItem("sessionId") === null)) {
			$("#logoutlink").show();
			$("#loginlink").hide();
			authenticate.isLoggedIn = true;
		} else {
			$("#logoutlink").hide();
			$("#loginlink").show();
			authenticate.isLoggedIn = false;
			$(":mobile-pagecontainer").pagecontainer( "change", "#login");
		}
	},
};