var cache = {
	setCacheData: function(cacheInfo, key, data) {
		window.localStorage.setItem(key, JSON.stringify(data));
		cache.setCacheInfo(cacheInfo);
	},
	getCacheData: function(key) {
		if(!(window.localStorage.getItem(key) === null)) {
			return JSON.parse(window.localStorage.getItem(key));	
		} else {
			return null;
		}
	},
	getCacheInfo: function(cacheName) {
		//localStorage.removeItem("cacheinfo");
		
		if(window.localStorage.getItem("cacheInfos") === null) {
			window.localStorage.setItem('cacheInfos', JSON.stringify({}));
		}
		if(JSON.parse(window.localStorage.getItem("cacheInfos"))[cacheName]) {
			logger.info("CACHE: existing cacheinfo: "+cacheName);
			var cacheInfo = JSON.parse(window.localStorage.getItem("cacheInfos"))[cacheName];
			cacheInfo.expired = moment(cacheInfo.lastAccess).add(app.cacheSettings[cacheName].timeout,app.cacheTimeoutUnit).isBefore(moment());
			return cacheInfo;
		} else {
			logger.info("CACHE: create new cacheinfo: "+cacheName);
			return {name: cacheName, expired: true, lastAccess: moment()};
		}
	},
	setCacheInfo: function(cacheInfo) {
		logger.info("CACHE: set cacheinfo: "+cacheInfo.name);
		// update last accessed timestamp and reset expired flag
		cacheInfo.lastAccess = moment();
		cacheInfo.expired = false;
		var cacheInfos = {};
		if(!(window.localStorage.getItem("cacheInfos") === null)) {
			cacheInfos = JSON.parse(window.localStorage.getItem("cacheInfos"));
		}
		cacheInfos[cacheInfo.name] = cacheInfo;
		window.localStorage.setItem('cacheInfos', JSON.stringify(cacheInfos));
	},
	clearCacheInfo: function(cacheName) {
		if(!(window.localStorage.getItem("cacheInfos") === null)) {
			var cacheInfos = JSON.parse(window.localStorage.getItem("cacheInfos"));
			if(cacheInfos[cacheName]) {
				cacheInfos[cacheName] = null;
				window.localStorage.setItem('cacheInfos', JSON.stringify(cacheInfos));
			}
		}	
	}
};