var enrolment = {
		
	initialize: function() {
		this.bindEvents();
	},
	bindEvents: function() {
        document.addEventListener('deviceready', this.deviceReady, false);
	},
	deviceReady: function() {
		enrolment.display();
		enrolment.getData();
	},
	getData: function() {
		if(authenticate.isLoggedIn) { // and if have data connection
			// check cache time
			var cacheInfo = cache.getCacheInfo("enrolledUnits");
			if(cacheInfo.expired) {
				var username = window.localStorage.getItem("username");
				var sessionId = window.localStorage.getItem("sessionId");
				var timestamp = new Date().getTime();
				var hash = CryptoJS.MD5(username+timestamp+device.uuid+sessionId)+"";
				hash = hash.toUpperCase();
				$.ajax({
					type: "GET",
					crossDomain: true,
					contentType: "application/json; charset=utf-8",
					url: app.mobileBaseUrl+app.enrolledUnitsUrl+username+"/"+timestamp+"/"+device.uuid+"/"+hash,
					dataType: "json",
					timeout: app.timeout*4,
                    success: function (json) {
                        //logger.debug("URL success: " + this.url);
						//logger.debug(JSON.stringify(json));
						if(json.status == 'success') {
							cache.setCacheData(cacheInfo, "enrolledUnits", json.enrollment);
							enrolment.display();
							unitinfo.getData();
							timetable.getData();
							results.getData();
							$.mobile.loading('hide');	
							logger.info("SUCCESS: enrolled-units");		
						} else {
							$.mobile.loading('hide');
							alert(json.message);
							logger.error("ERROR: enrolled-units: "+json.message);
							// clear data
							window.localStorage.clear(); 
							// goto login
							authenticate.checkLogin();
						}
					},
                    error: function (e) {
                        //logger.debug("URL error: " + this.url);
						$.mobile.loading('hide');
						logger.error("ERROR: enrolled-units function: "+JSON.stringify(e));
					}
				});
			}
		}
	},
	display: function() {
		var enrolledUnits = cache.getCacheData("enrolledUnits");
		if(!(enrolledUnits === null)) {
			// json is a list
			// for each list item
			var unitshtml = "";
			for(var unit in enrolledUnits) {
				// create new collapsible
				unitshtml += "<div data-role=\"collapsible\"><h3>"+enrolledUnits[unit].unitCode+" "+enrolledUnits[unit].title+"</h3>";
				unitshtml += "<ul data-role=\"listview\" data-theme=\"a\">";
				if(enrolledUnits[unit].moodleUrl) {
					unitshtml += "<li><a href=\"#\" onclick=\"window.open('"+app.casUrl+"?service="+encodeURIComponent(enrolledUnits[unit].moodleUrl)+"', '_system', 'location=yes');\" class=\"fastclick\">Moodle</a></li>";
				} 
				//logger.debug(window.localStorage.getItem('unit_'+unit));
				if(!(window.localStorage.getItem('unit_'+unit) === null)) {
					unitshtml += "<li><a href=\"#unitinfo\" onclick=\"unitinfo.display('"+enrolledUnits[unit].unitCode+"')\" class=\"fastclick\">Unit Information</a></li>";
					unitshtml += "<li><a href=\"#gradecalculator\" onclick=\"gradeCalculator.display('"+enrolledUnits[unit].unitCode+"')\" class=\"fastclick\">Grade Calculator</a></li>";
				}
				unitshtml += "</ul>";
				unitshtml += "</div>";	
			}
			
			$("#units").html(unitshtml);
			$('#units').find("ul[data-role=listview]").listview().listview("refresh");
			$('#units').find("div[data-role=collapsible]").collapsible();
			
			var button = document.querySelector(".fastclick");
			new FastClick(button);
		}
	},
};