var rssfeed = {
	initialize: function() {
		this.bindEvents();
	},
	bindEvents: function() {
        document.addEventListener('deviceready', this.deviceReady, false);
	},
	deviceReady: function() {
		rssfeed.display();
		rssfeed.getData();
	},
	getData: function() {
		var cacheInfo = cache.getCacheInfo("rssfeed");
		if(cacheInfo.expired) {
			$.getFeed({
				url: app.rssFeedUrl,
				success: function(feed) {
					cache.setCacheData(cacheInfo, "rssfeed", feed);
					logger.info("RSSFEED: SUCCESS");
					rssfeed.display();
				},
				error: function(e) {
					logger.error("RSSFEED: ERROR: ("+app.rssFeedUrl+") "+JSON.stringify(e));
				}				
			});
		}	
	},
	display: function() {
		var feed = cache.getCacheData("rssfeed");
		if(!(feed === null)) {
			var html = '';		
			for(var i = 0; i < feed.items.length && i < 10; i++) {
				var item = feed.items[i];
				html += "<a href=\"#\" onclick=\"window.open('"+item.link+"', '_system', 'location=yes');\" data-role=\"button\" class=\"rssfeeditemlink fastclick\">";
				//html += '<a href="' + item.link + '" class="rssfeeditemlink fastclick"><div class="rssfeeditem">';
				html += '<div class=\"rssfeeditem\"><h3>' + item.title + '</h3>';
				html += '<div class="updated">' + item.updated + '</div>';
				html += '<div class="rssfeeddescription">' + item.description + '</div>';
				html += '</div></a>';
			}
			$('#rssfeed').html(html);
		}
	},
};